<?php

/**
 * FpaCnabmagnet
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    DbModel
 * @subpackage Model
 * @author     thalesvalias - 26/07/2012 17:59:13 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class FpaCnabmagnet extends DaoFpaCnabmagnet
{


    /**
     * Retorna registros de acordo com a competencia, banco e tipo de movimento.
     *
     * @param string  $mesCompetencia  Mes de Competencia.
     * @param string  $nrOrg           Numero da Organizacao.
     * @param string  $cdBanco         Codigo do Banco.
     * @param integer $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return array FpacnabmagnetEntity
     *
     * @author thalesvalias - 26/07/2012
     */
    public static function retornaRegistros($mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento){
        $resultado = self::getObjectsByWhere(
            'MESCOMPETENCIA = ?
             AND NRORG = ?
             AND CDBANCO = ?
             AND NRTIPOMOVIMENT = ?',
            array(
                $mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento,
            ), 'IDTPINSCESTRUTU, CDINSCESTRUT, IDTIPOREGISTRO, NRVINCULOM, IDSEGMENTO'
        );
        return $resultado;
    }


    /**
     * Retorna registros por tipo, banco e tipo de movimento.
     *
     * @param TkDateTime $mesCompetencia    Mes de competencia.
     * @param string     $listaTipoRegistro Tipo de Registro.
     * @param integer    $nrOrg             Numero da Organizacao.
     * @param string     $cdBanco           Codigo do Banco.
     * @param integer    $nrTipoMovimento   Numero do Tipo de Movimento.
     *
     * @return FpacnabmagnetEntity
     *
     * @author thalesvalias - 02/08/2012
     */
    public static function retornaRegistrosPorTipo(TkDateTime $mesCompetencia, $listaTipoRegistro, $nrOrg, $cdBanco, $nrTipoMovimento){

        $resultado = self::getObjectsByWhere(
            'MESCOMPETENCIA = ?
            AND IDTIPOREGISTRO IN ('.$listaTipoRegistro.')
            AND NRORG = ?
            AND CDBANCO = ?
            AND NRTIPOMOVIMENT = ?',
            array(
                $mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento,
            )
        );
        return $resultado;
    }


    /**
     * Retorna registro.
     *
     * @param string $mesCompetencia  Mes de competencia.
     * @param string $nrOrg           Numero da Organizacao.
     * @param string $tipoRegistro    Tipo de registro.
     * @param string $segmento        Tipo do segmento do registro.
     * @param string $tipoInscricao   Tipo de Inscricao.
     * @param string $nrInscricao     Numero de Inscricao.
     * @param string $nrVinculoM      Numero do vinculo.
     * @param string $cdBanco         Codigo do Banco.
     * @param string $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return FpacnabmagnetEntity
     *
     * @author thalesvalias - 26/07/2012
     */
    public static function retornaRegistro(
        $mesCompetencia, $nrOrg, $tipoRegistro, $segmento, $tipoInscricao, $nrInscricao, $nrVinculoM, $cdBanco, $nrTipoMovimento){
        $resultado = self::getObjectByWhere(
            'MESCOMPETENCIA = ?
             AND NRORG = ?
             AND IDTIPOREGISTRO = ?
             AND IDSEGMENTO = ?
             AND IDTPINSCESTRUTU = ?
             AND CDINSCESTRUT = ?
             AND NRVINCULOM = ?
             AND CDBANCO = ?
             AND NRTIPOMOVIMENT = ?',
            array(
                $mesCompetencia, $nrOrg, $tipoRegistro, $segmento, $tipoInscricao, $nrInscricao, $nrVinculoM, $cdBanco, $nrTipoMovimento,
            )
        );

        return $resultado;
    }


    /**
     * Retorna o total de registros de acordo com os tipos de registro informados.
     *
     * @param string  $mesCompetencia  Mes de Competencia.
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $tiposRegistro   Tipos de Registros.
     * @param string  $cdBanco         Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return null || array
     *
     * @author thalesvalias 07/08/2012
     */
    public static function totalRegistrosPorTipos($mesCompetencia, $nrOrg, $tiposRegistro, $cdBanco, $nrTipoMovimento){
        $sql = "SELECT COUNT(1)
                FROM FPA_CNABMAGNET
                WHERE IDTIPOREGISTRO IN ($tiposRegistro)
                AND MESCOMPETENCIA = '$mesCompetencia '
                AND NRORG = '$nrOrg'
                AND CDBANCO = '$cdBanco'
                AND NRTIPOMOVIMENT = '$nrTipoMovimento'";

        $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);

        return $resultado;
    }


    /**
     * Retorna o ultimo(maior) numero sequencial do registro 0 de acordo com a competencia e o codigo do banco informados.
     *
     * @param string  $mesCompetencia  Mes de Competencia.
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $cdBanco         Codigo do Banco.
     *
     * @return null || array
     *
     * @author thalesvalias 10/08/2012
     */
    public static function retornaUltimoSequencialRegistro0($mesCompetencia, $nrOrg, $cdBanco){
        $sql = "SELECT MAX(NRSEQUENCIALARQUIVO)
                FROM FPA_CNABMAGNET
                WHERE IDTIPOREGISTRO = ".Registro0CNABSantander::REGISTRO_0."
                AND MESCOMPETENCIA = '$mesCompetencia '
                AND NRORG = '$nrOrg'
                AND CDBANCO = '$cdBanco'";

        $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);

        return $resultado;
    }


    /**
     * Retorna os registros 0 referentes ao mesmo envio ordenados.
     * Mesmo envio = mesma competencia e mesmo banco. Cada 0 representa um novo arquivo.
     *
     * @param string  $mesCompetencia  Mes de Competencia.
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $cdBanco         Codigo do Banco.
     *
     * @return null | array
     *
     * @author thalesvalias 10/08/2012
     */
    public static function retornaRegistros0Remessa($mesCompetencia, $nrOrg, $cdBanco){

        $resultado = self::getObjectsByWhere(
            'MESCOMPETENCIA = ?
            AND NRORG = ?
            AND IDTIPOREGISTRO = ?
            AND CDBANCO = ?',
            array(
                $mesCompetencia, $nrOrg, Registro0CNABSantander::REGISTRO_0, $cdBanco,
            ), 'NRTIPOMOVIMENT', 'NREVENTOM'
        );

        return $resultado;
    }

    /**
     * Retorna registros filtrados por vinculo para um segmento.
     *
     * @param integer    $nrOrg          Numero da Organizacao
     * @param TkDateTime $mesCompetencia Mes de Competencia
     * @param integer    $nrVinculom     Numero do Vinculo
     * @param string     $idSegmento     Identificador do segmento
     *
     * @return FpaCnabmagnetEntity | null
     *
     * @author alessandrobartels - 03/10/2012
     */
    public static function retornaRegistroPorVinculoSegmento($nrOrg, $mesCompetencia, $nrVinculom, $idSegmento){
        $resultado = self::getObjectByWhere(
            'NRORG = ?
            AND MESCOMPETENCIA = ?
            AND NRVINCULOM = ?
            AND IDSEGMENTO = ?',
            array(
                $nrOrg, $mesCompetencia, $nrVinculom, $idSegmento
            )
        );

        return $resultado;
    }

}
