/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SIST                                                     */
/* Tabela : SISTEMA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 22/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SIST
BEFORE INSERT OR UPDATE OR DELETE
ON SISTEMA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSIST := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUSIST := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SISTEMA', '', 'CDSISTEMA='||:OLD.CDSISTEMA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SISTEMA MODIFY DTULTATUSIST DEFAULT SYSDATE
/
