-- =============================================================== --
-- SISTEMA         : COMISSARIA                                    --
-- DATA DA CRIAO : INCIO - 10/11/99                             --
-- OBJETIVO        : Retorna o cdigo do agrupamento de delivery   --
-- MANUTENO      : 10/07/2001 TRATAMENTO MULTI-EMPRESA           --
-- @C:\WIN_PRJ\SQL\ORACLE\2706_ATESTP_RETORNA_AGRUP.SQL
-- =============================================================== --
CREATE OR REPLACE PROCEDURE RETORNA_AGRUPAMENTO(
  P_CDFILIAL     IN  FILIAL.CDFILIAL%TYPE,
  P_CDCIA        IN  COMPANHIA.CDCIA%TYPE,
  P_NRVOO        IN  VOO.NRVOO%TYPE,
  P_CDTRECHO     IN  VOOTRECHO.CDTRECHO%TYPE,
  P_CDCLASSE     IN  CLASSE.CDCLASSE%TYPE,
  P_CDEQUIP      IN  VOO.CDEQUIP%TYPE,
  P_SGPREFIXO    IN  PREFIXOCIA.SGPREFIXO%TYPE,
  P_CDAGRDEL     OUT AGRDELIVERY.CDAGRDEL%TYPE)

AS

  V_CONTAGR  NUMBER;
  V_CDAGRDEL AGRDELIVERY.CDAGRDEL%TYPE;
  V_SGCLASSE CLASSE.SGCLASSE%TYPE;

BEGIN
  V_CDAGRDEL := NULL;
  SELECT COUNT(*)
  INTO   V_CONTAGR
  FROM   CONFIGVOO
  WHERE (CDFILIAL = P_CDFILIAL) AND
        (CDCIA    = P_CDCIA   ) AND
        (NRVOO    = P_NRVOO   ) AND
        (CDTRECHO = P_CDTRECHO) AND
        (CDCLASSE = P_CDCLASSE);
  IF V_CONTAGR > 0 THEN
    SELECT CDAGRDEL
    INTO   V_CDAGRDEL
    FROM   CONFIGVOO
    WHERE (CDFILIAL = P_CDFILIAL) AND
          (CDCIA    = P_CDCIA   ) AND
          (NRVOO    = P_NRVOO   ) AND
          (CDTRECHO = P_CDTRECHO) AND
          (CDCLASSE = P_CDCLASSE);
  END IF;
  IF V_CDAGRDEL IS NULL THEN
    SELECT COUNT(*)
    INTO  V_CONTAGR
    FROM  CONFIGPREF
    WHERE (CDFILIAL  = P_CDFILIAL ) AND
          (CDCIA     = P_CDCIA    ) AND
          (SGPREFIXO = P_SGPREFIXO) AND
          (CDCLASSE  = P_CDCLASSE );
    IF V_CONTAGR > 0 THEN
      SELECT CDAGRDEL
      INTO   V_CDAGRDEL
      FROM   CONFIGPREF
      WHERE (CDFILIAL  = P_CDFILIAL ) AND
            (CDCIA     = P_CDCIA    ) AND
            (SGPREFIXO = P_SGPREFIXO) AND
            (CDCLASSE  = P_CDCLASSE );
    END IF;
    IF V_CDAGRDEL IS NULL THEN
      SELECT COUNT(*)
      INTO   V_CONTAGR
      FROM   CONFIGEQUI
      WHERE (CDFILIAL = P_CDFILIAL) AND
            (CDCIA    = P_CDCIA   ) AND
            (CDEQUIP  = P_CDEQUIP ) AND
            (CDCLASSE = P_CDCLASSE);
      IF V_CONTAGR > 0 THEN
        SELECT CDAGRDEL
        INTO   V_CDAGRDEL
        FROM   CONFIGEQUI
        WHERE (CDFILIAL = P_CDFILIAL) AND
              (CDCIA    = P_CDCIA   ) AND
              (CDEQUIP  = P_CDEQUIP ) AND
              (CDCLASSE = P_CDCLASSE);
      END IF;
    END IF;
  END IF;

  IF (V_CDAGRDEL IS NULL) OR (V_CDAGRDEL = ' ') THEN
    SELECT SGCLASSE
    INTO V_SGCLASSE
    FROM CLASSE
    WHERE CDCLASSE = P_CDCLASSE;
    Raise_Application_Error(-20501, '#Evoo_AgDel'||'     '||P_NRVOO||'*', True);

    /*Gerao interrompida. O vo '||P_NRVOO|| ' possui servio(s) para a classe '||V_SGCLASSE||' e esta no possui agrupamento de delivery cadastrado na opo "Configurao de Passageiros". '||
                                    'Verifique se este vo, seu prefixo ou equipamento possuem configurao de passageiros cadastradas corretamente.'*/
  END IF;

  P_CDAGRDEL := V_CDAGRDEL;

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('RETORNA_AGRUPAMENTO','4.11.022'); END;
/

